/*-*- mode: C; tab-width:4 -*-*/

/*
  Copyright (C) 2006 Jost Boekemeier

  This file is part of the PHP/Java Bridge.

  The PHP/Java Bridge ("the library") is free software; you can
  redistribute it and/or modify it under the terms of the GNU General
  Public License as published by the Free Software Foundation; either
  version 2, or (at your option) any later version.

  The library is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with the PHP/Java Bridge; see the file COPYING.  If not, write to the
  Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
  02111-1307 USA.

  Linking this file statically or dynamically with other modules is
  making a combined work based on this library.  Thus, the terms and
  conditions of the GNU General Public License cover the whole
  combination.

  As a special exception, the copyright holders of this library give you
  permission to link this library with independent modules to produce an
  executable, regardless of the license terms of these independent
  modules, and to copy and distribute the resulting executable under
  terms of your choice, provided that you also meet, for each linked
  independent module, the terms and conditions of the license of that
  module.  An independent module is a module which is not derived from
  or based on this library.  If you modify this library, you may extend
  this exception to your version of the library, but you are not
  obligated to do so.  If you do not wish to do so, delete this
  exception statement from your version. 
*/

#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <stdio.h>

/* convenience and SELinux security wrapper for java.  This file is
   called by the service script and should be tagged with appropriate
   security context (see chcon(1)). */

void usage(char*name){
  fprintf(stderr, "This file should not be called directly.\n");
  fprintf(stderr, "Tag this file with the javabridge_exec_t security context and set it to\n");
  fprintf(stderr, "suid/guid apache/apache. Example:\n");
  fprintf(stderr, "chcon -t javabridge_exec_t %s; chown apache:apache %s; chmod 6111 %s\n", name, name, name);
  exit(1);
}

char *stringdup(char *s) {
  if(!s) return s;
  return strdup(s);
}
  
int main(int argc, char**_argv){
  char **argv;
  char *error;
  int i;

  if(argc<5) usage(_argv[0]);

  argv=calloc(argc, sizeof*argv);
  for(i=0; i<argc-1; i++) 
	argv[i]=stringdup(_argv[i+1]);
  argv[i]=0;

  if(!getuid()) setreuid(geteuid(), -1);
  if(!getgid()) setregid(getegid(), -1);
  if(*argv[0]=='/') execv(argv[0], argv); else execvp(argv[0], argv);
  error = strerror(errno);
  execvp("java", argv);
  fprintf(stderr, "Could not execute %s: %s\n", argv[0], error);
  return 2;
}
